aboutsummaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
authorDarrick J. Wong <darrick.wong@oracle.com>2018-05-01 08:39:26 -0700
committerEryu Guan <guaneryu@gmail.com>2018-05-02 15:13:55 +0800
commit38cdd5be450e6e2c719709cca3da6580f8f875d0 (patch)
tree70d63e6ecdc86623ebc43301912dfe04f1c2d489
parentd0f42b25301041ee5c72025d0a00cc3b5f3dc3da (diff)
downloadxfstests-dev-38cdd5be450e6e2c719709cca3da6580f8f875d0.tar.gz
generic: test XATTR_REPLACE doesn't take the fs down
Kanda Motohiro reported that expanding a tiny xattr into a large xattr fails on XFS because we remove the tiny xattr from a shortform fork and then try to re-add it after converting the fork to extents format having not removed the ATTR_REPLACE flag. This fails because the attr is no longer present, causing a fs shutdown. [Eryu: introduce function "fail" and use it where appropriate] Bugzilla: https://bugzilla.kernel.org/show_bug.cgi?id=199119 Reported-by: kanda.motohiro@gmail.com Signed-off-by: Darrick J. Wong <darrick.wong@oracle.com> Reviewed-by: Eryu Guan <guaneryu@gmail.com> Signed-off-by: Eryu Guan <guaneryu@gmail.com>
-rw-r--r--.gitignore1
-rw-r--r--src/Makefile3
-rw-r--r--src/attr_replace_test.c67
-rwxr-xr-xtests/generic/48671
-rw-r--r--tests/generic/486.out2
-rw-r--r--tests/generic/group1
6 files changed, 144 insertions, 1 deletions
diff --git a/.gitignore b/.gitignore
index 192ca35e15..53029e244d 100644
--- a/.gitignore
+++ b/.gitignore
@@ -52,6 +52,7 @@
/src/alloc
/src/append_reader
/src/append_writer
+/src/attr_replace_test
/src/attr-list-by-handle-cursor-test
/src/bstat
/src/bulkstat_unlink_test
diff --git a/src/Makefile b/src/Makefile
index 6ca5636639..c42d3bb1c5 100644
--- a/src/Makefile
+++ b/src/Makefile
@@ -25,7 +25,8 @@ LINUX_TARGETS = xfsctl bstat t_mtab getdevicesize preallo_rw_pattern_reader \
seek_copy_test t_readdir_1 t_readdir_2 fsync-tester nsexec cloner \
renameat2 t_getcwd e4compact test-nextquota punch-alternating \
attr-list-by-handle-cursor-test listxattr dio-interleaved t_dir_type \
- dio-invalidate-cache stat_test t_encrypted_d_revalidate
+ dio-invalidate-cache stat_test t_encrypted_d_revalidate \
+ attr_replace_test
SUBDIRS = log-writes perf
diff --git a/src/attr_replace_test.c b/src/attr_replace_test.c
new file mode 100644
index 0000000000..23adc072e5
--- /dev/null
+++ b/src/attr_replace_test.c
@@ -0,0 +1,67 @@
+// setattr.c by kanda.motohiro@gmail.com
+// xfs extended attribute corruption bug reproducer
+#include <stdio.h>
+#include <string.h>
+#include <fcntl.h>
+#include <errno.h>
+#include <stdlib.h>
+#include <unistd.h>
+#include <sys/types.h>
+#include <sys/xattr.h>
+#include <sys/stat.h>
+
+#define die() do { perror(""); \
+fprintf(stderr, "error=%d at line %d\n", errno, __LINE__); \
+exit(1); } while (0)
+
+#define fail(...) do { \
+fprintf(stderr, __VA_ARGS__); exit (1); \
+} while (0)
+
+int main(int argc, char *argv[])
+{
+ int ret;
+ int fd;
+ char *path;
+ char *name = "user.world";
+ char *value;
+ struct stat sbuf;
+ size_t size = sizeof(value);
+
+ if (argc != 2)
+ fail("Usage: %s <file>\n", argv[0]);
+ path = argv[1];
+
+ fd = open(path, O_RDWR | O_CREAT, S_IRUSR | S_IWUSR);
+ if (fd < 0) die();
+
+ /*
+ * The value should be 3/4 the size of a fs block to ensure that we
+ * get to extents format.
+ */
+ ret = fstat(fd, &sbuf);
+ if (ret < 0) die();
+ size = sbuf.st_blksize * 3 / 4;
+ if (!size)
+ fail("Invalid st_blksize(%ld)\n", sbuf.st_blksize);
+ value = malloc(size);
+ if (!value)
+ fail("Failed to allocate memory\n");
+
+ /* First, create a small xattr. */
+ memset(value, '0', 1);
+ ret = fsetxattr(fd, name, value, 1, XATTR_CREATE);
+ if (ret < 0) die();
+ close(fd);
+
+ fd = open(path, O_RDWR);
+ if (fd < 0) die();
+
+ /* Then, replace it with bigger one, forcing short form to leaf conversion. */
+ memset(value, '1', size);
+ ret = fsetxattr(fd, name, value, size, XATTR_REPLACE);
+ if (ret < 0) die();
+ close(fd);
+
+ return 0;
+}
diff --git a/tests/generic/486 b/tests/generic/486
new file mode 100755
index 0000000000..f67cca9f92
--- /dev/null
+++ b/tests/generic/486
@@ -0,0 +1,71 @@
+#! /bin/bash
+# FS QA Test No. 486
+#
+# Ensure that we can XATTR_REPLACE a tiny attr into a large attr.
+# Kanda Motohiro <kanda.motohiro@gmail.com> reports that XATTR_REPLACE'ing
+# a single-byte attr with a 2048-byte attr causes a fs shutdown because we
+# remove the shortform attr, convert the attr fork to long format, and then
+# try to re-add the attr having not cleared ATTR_REPLACE.
+#
+# Commit 7b38460dc8e4 ("xfs: don't fail when converting shortform attr to long
+# form during ATTR_REPLACE") fixed the xfs bug.
+#
+#-----------------------------------------------------------------------
+# Copyright (c) 2018 Oracle. All Rights Reserved.
+#
+# This program is free software; you can redistribute it and/or
+# modify it under the terms of the GNU General Public License as
+# published by the Free Software Foundation.
+#
+# This program is distributed in the hope that it would be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write the Free Software Foundation,
+# Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+#
+#-----------------------------------------------------------------------
+
+seq=`basename $0`
+seqres=$RESULT_DIR/$seq
+echo "QA output created by $seq"
+
+status=1 # failure is the default!
+trap "_cleanup; exit \$status" 0 1 2 3 15
+
+_cleanup()
+{
+ cd /
+ rm -f $testfile
+}
+
+# get standard environment, filters and checks
+. ./common/rc
+. ./common/filter
+. ./common/attr
+
+# remove previous $seqres.full before test
+rm -f $seqres.full
+
+# real QA test starts here
+_supported_fs generic
+_supported_os Linux
+_require_test_program "attr_replace_test"
+_require_attrs
+_require_scratch
+
+rm -f $seqres.full
+_scratch_mkfs >>$seqres.full 2>&1
+_scratch_mount >>$seqres.full 2>&1
+
+filter_attr_output() {
+ _filter_scratch | sed -e 's/has a [0-9]* byte value/has a NNNN byte value/g'
+}
+
+./src/attr_replace_test $SCRATCH_MNT/hello
+$ATTR_PROG -l $SCRATCH_MNT/hello | filter_attr_output
+
+status=0
+exit
diff --git a/tests/generic/486.out b/tests/generic/486.out
new file mode 100644
index 0000000000..c57c7c9617
--- /dev/null
+++ b/tests/generic/486.out
@@ -0,0 +1,2 @@
+QA output created by 486
+Attribute "world" has a NNNN byte value for SCRATCH_MNT/hello
diff --git a/tests/generic/group b/tests/generic/group
index d04b203d0e..505383f706 100644
--- a/tests/generic/group
+++ b/tests/generic/group
@@ -488,3 +488,4 @@
483 auto quick log metadata
484 auto quick
485 auto quick insert
+486 auto quick attr